<?php

// backend of rssViewer
// version: 0.3
// date:    2004.03.13
// author:  erational <http://wwww.erational.org>

require("./lib/inc_globals.php");
require("./lib/inc_sql.php");

// header:  xml and no cache
header("Content-type: application/xml");		
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");              
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");   
header("Cache-Control: no-cache, must-revalidate");           // HTTP/1.1  
header("Pragma: no-cache");                                   // HTTP/1.0

// Now support register_globals=OFF 
$category = $_GET['category'];
$id = $_GET['id'];
$action = $_GET['action'];


function displayCategory($category) {
    $connect = db_connect(USERNAME,PASSWORD,HOSTNAME,DATABASE);
	$query = "SELECT  rss_id, rss_desc 
				FROM  db_RSS_uri											
				WHERE rss_category='$category'
				ORDER BY rss_desc";												
	$result = execQuery($query);
	while ($pt = nextLine($result)) {
				echo "<rssfeed name=\"".$pt->rss_desc."\">".$pt->rss_id."</rssfeed>";									
	}
}

//action
if (isset($action)) {   
  switch ($action) {
  		case "viewCat" :    // display categories							
							$connect = db_connect(USERNAME,PASSWORD,HOSTNAME,DATABASE);
							$query = "SELECT  rss_category, rss_name FROM db_RSS_category ORDER BY rss_name LIMIT 100";														
							$result = execQuery($query);
							echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>";
							echo "<categories>";
							while ($pt = nextLine($result)) {
									echo "<category>".$pt->rss_name."</category>";	
							}
							echo "</categories>";							
							break;
							
		 case "viewFeed" :   // display rss from a given category
		 					echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>";		 					
							echo "<rssfeeds>";
		 					if (isset($id))   displayCategory($id);
							echo "</rssfeeds>";								
							break;
							
		case "viewRSS":     // display a distant rss																
		 					if (isset($id)) {																
								$connect = db_connect(USERNAME,PASSWORD,HOSTNAME,DATABASE);
								$query = "SELECT  rss_uri
											FROM  db_RSS_uri											
											WHERE rss_id='$id'
											LIMIT 1";																				
								$result = execQuery($query);
								while ($pt = nextLine($result)) {								      									   
							    		readfile($pt->rss_uri);
								}
							} 															
							break;
							
		 case "delItem":     // delete Item and refresh the given category									
		 					if (isset($id)) {									
								$connect = db_connect(USERNAME,PASSWORD,HOSTNAME,DATABASE);
								$query = "DELETE FROM  db_RSS_uri											
											WHERE rss_id='$id'
											LIMIT 1";																				
								$result = execQuery($query);																								
							} 
							echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>";		 					
							echo "<rssfeeds>";
		 					if (isset($cat)) displayCategory($cat);
							echo "</rssfeeds>";															
							break;
							
		case "addItem":     // add Item and refresh the given category									
		 					if (isset($id)) {									
								$connect = db_connect(USERNAME,PASSWORD,HOSTNAME,DATABASE);								
								$query = "INSERT INTO db_RSS_uri (rss_id, rss_category, rss_uri, rss_desc)											
											   VALUES ('', '$cat', '$url', '$id')";																
								$result = execQuery($query);																								
							} 
							echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>";		 					
							echo "<rssfeeds>";
		 					if (isset($cat)) displayCategory($cat);
							echo "</rssfeeds>";																						
							break;
														
																
			default :		echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>";
							echo "<error>action unknown !</error>";
							break;
  } 
} else {
  echo "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>";
  echo "<error>no action !</error>";
}
?>